//=====================================================
// JavaScript functions for tagging support
//
// Copyright (c) 2006, IBM T.J. Watson Research Center.
// All rights reserved.
//=====================================================


//checks for invalid chars already on the client side
//if you make changes here, also change the function 
//in the Web application (currently Tags.cpp)
function checkChars(s) {
	if (s.indexOf("@") != -1) return "@";
	if (s.indexOf("#") != -1) return "#";
	if (s.indexOf("&") != -1) return "&";
	if (s.indexOf("\\") != -1) return "\\";
	if (s.indexOf("%") != -1) return "%";
	if (s.indexOf("/") != -1) return "/";
	if (s.indexOf(":") != -1) return ":";
	if (s.indexOf(".") != -1) return ".";
	if (s.indexOf("*") != -1) return "*";
	if (s.indexOf("?") != -1) return "?";
	if (s.indexOf("\"") != -1) return "\"";
	if (s.indexOf("<") != -1) return "<";
	if (s.indexOf(">") != -1) return ">";
	if (s.indexOf("|") != -1) return "|";
	return "";
}

//tags are also checked on the server side, but
//it's more performant to check it on the client side first
function checkTags(textbox) {
	var s = textbox.value;
	textbox.focus();
	if (s=='') {
		alert("Please enter a Tag first");
		return false;
	}
	var inval = checkChars(s);
	if (inval != "") {
		alert('Invalid Character: ' + inval + '  Please correct your input.');
		return false;
	}
	return true;
}


//hide element s1, show element s2, give focus to focusField
function changeVisibility (toHide, toShow, focusField, displayStyle) {
  if (document.getElementById) {
    if (toHide != '') document.getElementById(toHide).style.display = "none";
//	if (toShow != '') document.getElementById(toShow).style.display = "inline";
	if (toShow != '') document.getElementById(toShow).style.display = displayStyle;
	focusField.focus();
  }
}


// hide element with ID=itemID and change inline html text of link
// to show onText if item is being switched on, and offText otherwise
function toggleVisibility (itemID, linkID, onText, offText) {
  if (document.getElementById && itemID != '' && linkID != '') {
    var item = document.getElementById(itemID);
    var link = document.getElementById(linkID);
    
    if (item.style.display == "none") {
//        item.style.display = "inline"; // this messes up overflow:hidden for some reason
        item.style.display = "block";
        link.innerHTML = onText;
	} else {
	    item.style.display = "none";
        link.innerHTML = offText;
    }
  }
}


// as above but directly sets visibility on/off instead of toggling
function setVisibility (itemID, linkID, linkText, on) {
  if (document.getElementById && itemID != '' && linkID != '') {
    var item = document.getElementById(itemID);
    var link = document.getElementById(linkID);
    var style = (on ? "block" : "none");
    
    item.style.display = style;
    link.innerHTML = linkText;
  }
}


// as above but iterates over a range of elements to toggle
function setBulkVisibility (itemIDprefix, linkIDprefix, linkText, on, startID, endID) {
  if (document.getElementById && itemIDprefix != '' && startID <= endID) {
    var i;
    for (i = startID; i <= endID; i++) {
        setVisibility(itemIDprefix + i, linkIDprefix + i, linkText, on);
    }
  }
}


function confirmRemove(tag) {
	var msg = ((tag=='*') ? "Remove all Tags from current Image?" : "Remove Tag \"" + tag + "\" ?");
	var check = confirm(msg);
	if (check) return true;
	else return false;
}


function appendWord(input, word) {
    if (input) {
        input.focus();
        if (input.value.length > 0) input.value += ' '; 
        input.value += word + ' '; 
        setCaret(input, input.value.length);
    }
}

function prependWord(input, word) {
    if (input) {
        input.focus();
        input.value = word + ' ' + input.value; 
        setCaret(input, word.length+1);
    }
}

